﻿var bgLayout = "1";
var rahmen = "2";
var overlay = "6";
var app = "http://jacek-piotr.com/gadget.html";



function start() {
	System.Gadget.settingsUI = "settings.html";
	System.Gadget.onSettingsClosed = settingsClosed;
}

function settingsClosed() {
	app = System.Gadget.Settings.read("app");
	bgLayout = System.Gadget.Settings.read("bgLayout");
	rahmen = System.Gadget.Settings.read("rahmen");
	System.Gadget.background = "img/" + bgLayout + "-" + rahmen + ".png";

	if (System.Gadget.Settings.read("overlay")) {
		overlay = System.Gadget.Settings.read("overlay");
	}
	var overlay2 = "url(/img/overlay-" + overlay +".png) no-repeat";
	document.getElementById("calendar").style.background = overlay2;
}

function executeShellCmd() {
	if(app != " ") {
		System.Shell.execute(app);
	}
	shake();	
}


function shake() {
	effect.style.filter = "progid:DXImageTransform.Microsoft.Pixelate(duration=0.5, maxSquare=11)"
	effect.filters[0].apply();
	effect.filters[0].play();
}


/**********************************************************************
*          Calendar JavaScript [DOM] v3.03 by Michael Loesler          *
************************************************************************
* Copyright (C) 2005-08 by Michael Loesler, http//derletztekick.com    *
*                                                                      *
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 3 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* This program is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with this program; if not, see <http://www.gnu.org/licenses/>  *
* or write to the                                                      *
* Free Software Foundation, Inc.,                                      *
* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
*                                                                      *
 **********************************************************************/

function CalendarJS() {

	if (System.Gadget.Settings.read("bgLayout")) {
		bgLayout = System.Gadget.Settings.read("bgLayout");
	}
	if (System.Gadget.Settings.read("rahmen")) {
		rahmen = System.Gadget.Settings.read("rahmen");
	}
	if (System.Gadget.Settings.read("overlay")) {
		overlay = System.Gadget.Settings.read("overlay");
	}
	if (System.Gadget.Settings.read("app")) {
		app = System.Gadget.Settings.read("app");
	}


	System.Gadget.background = "url(img/"+ bgLayout + "-" + rahmen + ".png)";
	var overlay2 = "url(/img/overlay-" + overlay +".png) no-repeat";
	document.getElementById("calendar").style.background = overlay2;

		this.now = new Date();
		this.dayname = ["P","W","Ś","C","P","S","N"];
		this.monthname = ["Styczeń","Luty","Marzec","Kwiecień","Maj","Czerwiec","Lipiec","Sierpień","Wrzesień","Październik","Listopad","Grudzień"];	

		this.tooltip = ["Poprzedni miesiąc","Następny miesiąc","Aktualna data"];
		this.monthCell = document.createElement("th");
		this.tableHead = null;
		this.parEl = null;
		
		this.init = function( id ) {
			this.date = this.now.getDate();
			this.month = this.mm = this.now.getMonth();
			this.year = this.yy = this.now.getFullYear();
			this.monthCell.colSpan = 5;
			this.monthCell.appendChild(document.createTextNode( this.monthname[this.mm]+" "+this.yy ));
			this.tableHead = this.createTableHead();
			this.parEl = document.getElementById( id );
			this.show();
			this.checkDate();
		}

		this.checkDate = function() {
			var self = this;
			var today = new Date();
			if (this.date != today.getDate()) {
				this.date  = today.getDate();
				this.month = today.getMonth();
				this.year  = today.getFullYear();
				this.switchMonth("current");
 			}
			window.setTimeout(function() { self.checkDate(); }, 1000);
		},

		this.removeElements = function( Obj ) {
			for (var i=0; i<Obj.childNodes.length; i++)
				Obj.removeChild(Obj.childNodes[i]);
			return Obj;
		}

		this.show = function() {
			this.parEl = this.removeElements( this.parEl );
			this.monthCell.firstChild.replaceData(0, this.monthCell.firstChild.nodeValue.length, this.monthname[this.mm]+" "+this.yy);
			var table = document.createElement("table");
			table.appendChild( this.createTableBody() );
			table.appendChild( this.tableHead );
			this.parEl.appendChild( table );

			effect.style.filter = "progid:DXImageTransform.Microsoft.Pixelate(duration=0.5, maxSquare=11)"
			effect.filters[0].apply();
			effect.filters[0].play();
		}

				
		this.createTableHead = function() {
			var thead = document.createElement("thead");
			var tr = document.createElement("tr");
			var th = this.getCell( "th", "\u00AB", "last_month" )
			th.Instanz = this;
			th.onclick = function() { this.Instanz.switchMonth("prev"); };
			th.title = this.tooltip[0];
			try { th.style.cursor = "pointer"; } catch(e){ th.style.cursor = "hand"; }
			tr.appendChild( th );
			this.monthCell.Instanz = this;
			this.monthCell.onclick = function() { this.Instanz.switchMonth("current"); };
			this.monthCell.title = this.tooltip[2];
			this.monthCell.id = "effect";
			try { this.monthCell.style.cursor = "pointer"; } catch(e){ this.monthCell.style.cursor = "hand"; }
			tr.appendChild( this.monthCell );			
			th = this.getCell( "th", "\u00BB", "next_month" )
			th.Instanz = this;
			th.onclick = function() { this.Instanz.switchMonth("next"); };
			th.title = this.tooltip[1];
			try { th.style.cursor = "pointer"; } catch(e){ th.style.cursor = "hand"; }
			tr.appendChild( th );
			thead.appendChild( tr );
			tr = document.createElement('tr');
			for (var i=0; i<this.dayname.length; i++)
				tr.appendChild( this.getCell("th", this.dayname[i], "weekday" ) );
			thead.appendChild( tr );
			return thead;
		}
		
		this.createTableBody = function() {
			var dayspermonth = [31,28,31,30,31,30,31,31,30,31,30,31];
			var sevendaysaweek = 0;
			var begin = new Date(this.yy, this.mm, 1);
			var firstday = begin.getDay()-1;
			if (firstday < 0)
				firstday = 6;
			if ((this.yy%4==0) && ((this.yy%100!=0) || (this.yy%400==0)))
				dayspermonth[1] = 29;
			var tbody = document.createElement("tbody");
			var tr = document.createElement('tr');
			
			if (firstday == 0) {
				for (var i=0; i<this.dayname.length; i++) {
					var prevMonth = (this.mm == 0)?11:this.mm-1;
					tr.appendChild( this.getCell( "td", dayspermonth[prevMonth]-6+i, "last_month" ) );
				}
				tbody.appendChild( tr );
				tr = document.createElement('tr');
			}

			for (var i=0; i<firstday; i++, sevendaysaweek++) {
				var prevMonth = (this.mm == 0)?11:this.mm-1;
				tr.appendChild( this.getCell( "td", dayspermonth[prevMonth]-firstday+i+1, "last_month" ) );
			}


			for (var i=1; i<=dayspermonth[this.mm]; i++, sevendaysaweek++){
				if (this.dayname.length == sevendaysaweek){
					tbody.appendChild( tr );
					tr = document.createElement('tr');
					sevendaysaweek = 0;
				}

			var tmpMM = this.mm+1;
			if(tmpMM<10) {
				tmpMM='0' +tmpMM;
			}
			var tmpYY	= new String(this.yy);
			var tmpYY2	= tmpYY.substr(2, 3);

			var mytitle = i + "." + tmpMM + "." + tmpYY2 + " KW " + (KalenderWoche(this.yy, tmpMM, i));

			var myMN = this.monthname[this.mm];
			var myYN	= this.yy

				if (i==this.date && this.mm==this.month && this.yy==this.year && (sevendaysaweek == 5 || sevendaysaweek == 6))
					tr.appendChild( this.getCell( "td", i, "today weekend", mytitle, myMN, myYN ) );
				else if (i==this.date && this.mm==this.month && this.yy==this.year)
					tr.appendChild( this.getCell( "td", i, "today", mytitle, myMN, myYN ) );
				else if (sevendaysaweek == 5)
					tr.appendChild( this.getCell( "td", i, "saturday weekend", mytitle, myMN, myYN ) );
				else if (sevendaysaweek == 6)
					tr.appendChild( this.getCell( "td", i, "sunday weekend", mytitle, myMN, myYN ) );
				else
					tr.appendChild( this.getCell( "td", i, null, mytitle, myMN, myYN ) );
			} 


			var daysNextMonth = 1;
			for (var i=sevendaysaweek; i<this.dayname.length; i++) 
				tr.appendChild( this.getCell( "td", daysNextMonth++, "next_month"  ) );

			tbody.appendChild( tr );	

			while (tbody.getElementsByTagName("tr").length<6) {	
				tr = document.createElement('tr');
				for (var i=0; i<this.dayname.length; i++) 
					tr.appendChild( this.getCell( "td", daysNextMonth++, "next_month"  ) );
				tbody.appendChild( tr );
			}
	
	
			return tbody;
			
		}


		
			function KalenderWoche(j,m,t) {
			  var Datum = new Date();
			  if (!t) {
			    j = Datum.getYear(); if (1900 > j) j +=1900;
			    m = Datum.getMonth(); t = Datum.getDate();
			  }
			  else m--;
			  Datum = new Date(j,m,t,0,0,1);
			  var tag = Datum.getDay(); if (tag == 0) tag = 7;
			  var d = new Date(2004,0,1).getTimezoneOffset();
			  var Sommerzeit = (Date.UTC(j,m,t,0,d,1) - Number(Datum)) /3600000;
			  Datum.setTime(Number(Datum) + Sommerzeit*3600000 - (tag-1)*86400000);
			  var Jahr = Datum.getYear(); if (1900 > Jahr) Jahr +=1900;
			  var kw = 1;
			  if (new Date(Jahr,11,29) > Datum) {
			    var Start = new Date(Jahr,0,1);
			    Start = new Date(Number(Start) + 86400000*(8-Start.getDay()));
			    if(Start.getDate() > 4) Start.setTime(Number(Start) - 604800000);
			    kw = Math.ceil((Datum.getTime() - Start) /604800000);
			  }
			  return kw;
			}


	
		this.getCell = function(tag, str, cssClass, xtitle, xmyMN, xmyYN) {
			var El = document.createElement( tag );
			El.appendChild(document.createTextNode( str ));
			if (cssClass != null)
				El.className = cssClass;
			if (xtitle != null) {


				if(cssClass != "today" && cssClass != "today weekend" ) {
					El.onmouseover = function(e) { 
						this.style.background="url(/img/bg-today-m.png) no-repeat"; 
						this.style.color="#ffffff";
						effect.style.filter = "progid:DXImageTransform.Microsoft.Pixelate(duration=0.2, maxSquare=11)";
						effect.filters[0].apply();
						effect.firstChild.replaceData(0, effect.firstChild.nodeValue.length, xtitle);
						effect.filters[0].play();
					}
					El.onmouseout = function(e) { 
						this.style.background=""; 
						this.style.color="#eeeeee";
						effect.style.filter = "progid:DXImageTransform.Microsoft.Pixelate(duration=0.5, maxSquare=11)";
						effect.filters[0].apply();
						effect.firstChild.replaceData(0, effect.firstChild.nodeValue.length, xmyMN+" "+xmyYN);
						effect.filters[0].play();
					}
				}else{
					El.onmouseover = function(e) { 
						this.style.background="url(/img/bg-today-m.png) no-repeat"; 
						this.style.color="#ffffff";
						effect.style.filter = "progid:DXImageTransform.Microsoft.Pixelate(duration=0.2, maxSquare=11)";
						effect.filters[0].apply();
						effect.firstChild.replaceData(0, effect.firstChild.nodeValue.length, xtitle);
						effect.filters[0].play();
					}
					El.onmouseout = function(e) { 
						this.style.background="url(/img/bg-today.png) no-repeat"; 
						this.style.color="#000000";
						effect.style.filter = "progid:DXImageTransform.Microsoft.Pixelate(duration=0.5, maxSquare=11)";
						effect.filters[0].apply();
						effect.firstChild.replaceData(0, effect.firstChild.nodeValue.length, xmyMN+" "+xmyYN);
						effect.filters[0].play();

					}
				}

			}
			return El;
		}
		
		this.switchMonth = function( s ){
			switch (s) {
				case "prev": 
					this.yy = (this.mm == 0)?this.yy-1:this.yy;
					this.mm = (this.mm == 0)?11:this.mm-1;
				break;
				
				case "next":
					this.yy = (this.mm == 11)?this.yy+1:this.yy;
					this.mm = (this.mm == 11)?0:this.mm+1;
				break;
				
				case "current":
					this.yy = this.year;
					this.mm = this.month;
				break;
			}
			this.show();
		}
	}
	
	var DOMContentLoaded = false;
	function addContentLoadListener (func) {
		if (document.addEventListener) {
			var DOMContentLoadFunction = function () {
				window.DOMContentLoaded = true;
				func();
			};
			document.addEventListener("DOMContentLoaded", DOMContentLoadFunction, false);
		}
		var oldfunc = (window.onload || new Function());
		window.onload = function () {
			if (!window.DOMContentLoaded) {
				oldfunc();
				func();
			}
		};
	}


	addContentLoadListener( function() { 
			new CalendarJS().init("calendar");
			addContentLoadListener( dispImg() ); 
	}


);


addContentLoadListener( start() );


